<?php
	// Переименовываем модуль "Шаблоны" в "Рендеринг", что бы не путатся в названиях
class ux_language extends language {
	/**
	 * splitLabel function
	 * Historically labels were exploded by '|' and each part would correspond
	 * to the translation of the language found at the same 'index' in the TYPO3_languages constant.
	 * Today all translations are based on $LOCAL_LANG variables.
	 * 'language-splitted' labels can therefore refer to a local-lang file + index instead!
	 * It's highly recommended to use the 'local_lang' method
	 * (and thereby it's highly deprecated to use 'language-splitted' label strings)
	 * Refer to 'Inside TYPO3' for more details
	 *
	 * @param	string $input	Label key/reference
	 * @param	boolean	$hsc	If set, the return value is htmlspecialchar'ed
	 * @return	string
	 * @access	public
	 */
	public function sL($input, $hsc = FALSE) {
		foreach ($GLOBALS['LANG']->LL_files_cache['EXT:tstemplate/ts/locallang_mod.xml'] as $k => $v){
			$GLOBALS['LANG']->LL_files_cache['EXT:tstemplate/ts/locallang_mod.xml'][$k]['mlang_tabs_tab'][0]['source'] = "Rendering";
			$GLOBALS['LANG']->LL_files_cache['EXT:tstemplate/ts/locallang_mod.xml'][$k]['mlang_tabs_tab'][0]['target'] = "Rendering";
		}
		return parent::sL($input, $hsc);
	}
}
?>