<?php // файл содержит дополнительные фукнции...

//Скрипт перевода размера файла из байтов в КБ, МБ
function HumanBytes($size) {
   
	$filesizename = array(" Bytes", " Kb", " Mb", " Gb", " Tb", " Pb", " Eb", " Zb", " Yb");
    return $size ? round($size / pow(1024, ($i = floor(log($size, 1024)))), 2) . $filesizename[$i] : '0 Bytes';

} 


// Вычисляем размер БД
function information_schema_DB_size ( $dbName ) {

	$res = $GLOBALS['TYPO3_DB']->sql_query("
	
		SELECT table_schema 'DB Name', 
		   Sum(data_length + index_length) 'DB Size' 
		FROM   information_schema.tables
		WHERE TABLE_SCHEMA = '{$dbName}' ;
	
	");
	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
	return $row['DB Size'];
	
}

// Кол-во таблиц в БД
function information_schema_DB_tableCount ( $dbName ) {

	$res = $GLOBALS['TYPO3_DB']->sql_query("
	
		SELECT count(*) AS 'COUNT Table in DB' FROM information_schema.tables 
		WHERE TABLE_SCHEMA = '{$dbName}' ;
	
	");
	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
	return $row['COUNT Table in DB'];

}

// Кол-во записей // подсчет кол-ва строк в таблице...
function countRecordsInTable($tablename, $where = null){

	$res = $GLOBALS['TYPO3_DB']->sql_query("
	
		SELECT count(`uid`) AS 'COUNT Records in Table' FROM {$tablename}
		{$where};
	
	");
	
	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
	if ($row['COUNT Records in Table'] <= 0)
	return "0";
	else
	return $row['COUNT Records in Table'];

}

// Кол-во утерянных страниц в дереве (встраницы в не нерева)
function countSkullPage ( ){

	$res = $GLOBALS['TYPO3_DB']->sql_query("
	
		SELECT count(*) AS 'COUNT Skull Page in DB' FROM pages
		WHERE pid NOT IN (SELECT uid FROM pages) AND pid > 0
	
	");
	$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
	if ($row['COUNT Skull Page in DB'] > 0)
	return $row['COUNT Skull Page in DB'];
	else
	return 0;
	
}


// Определение размера папки
// http://stackoverflow.com/questions/478121/php-get-directory-size
//размер дирректории (в нашем случае йаловой системы
function uf_getDirSize($dir, $unit = 'm')
{
    $dir = trim($dir, '/');
    if (!is_dir($dir)) {
        trigger_error("{$dir} not a folder/dir/path.", E_USER_WARNING);
        return false;
    }
    if (!function_exists('exec')) {
        trigger_error('The function exec() is not available.', E_USER_WARNING);
        return false;
    }
    $output = exec('du -sb ' . $dir);
    $filesize = (int) trim(str_replace($dir, '', $output));
    /* switch ($unit) {
        case 'g': $filesize = number_format($filesize / 1073741824, 3) . " g"; break;  // giga
        case 'm': $filesize = number_format($filesize / 1048576, 1) . " m";    break;  // mega
        case 'k': $filesize = number_format($filesize / 1024, 0) . " k";       break;  // kilo
        case 'b': $filesize = number_format($filesize, 0) . " b";			   break;  // byte
    }*/
    
	//return ( $filesize + 0 );
	return $filesize;
	
}

/* 
 function getTotalSize($dir)
{
    $dir = rtrim(str_replace('\\', '/', $dir), '/');

    if (is_dir($dir) === true) {
        $totalSize = 0;
        $os        = strtoupper(substr(PHP_OS, 0, 3));
        // If on a Unix Host (Linux, Mac OS)
        if ($os !== 'WIN') {
            $io = popen('/usr/bin/du -sb ' . $dir, 'r');
            if ($io !== false) {
                $totalSize = intval(fgets($io, 80));
                pclose($io);
                //return $totalSize;
            }
        }
        // If on a Windows Host (WIN32, WINNT, Windows)
        if ($os === 'WIN' && extension_loaded('com_dotnet')) {
            $obj = new \COM('scripting.filesystemobject');
            if (is_object($obj)) {
                $ref       = $obj->getfolder($dir);
                $totalSize = $ref->size;
                $obj       = null;
                //return $totalSize;
            }
        }
        // If System calls did't work, use slower PHP 5
        $files = new \RecursiveIteratorIterator(new \RecursiveDirectoryIterator($dir));
        foreach ($files as $file) {
            $totalSize += $file->getSize();
        }
		//return $totalSize;
    } //else if (is_file($dir) === true) {
		//return filesize($dir);
    //}
	
	 //$filesizename = array(" Bytes", " Kb", " Mb", " Gb", " Tb", " Pb", " Eb", " Zb", " Yb");
	//return round($size / pow(1024, ($i = floor(log($size, 1024)))), 2) . $totalSize[$i] : '0 Bytes';
} */

//print PATH_site . "fileadmin/";
//print uf_getDirSize( "./../fileadmin/_temp_/" );
//exit();



//Класс проверки на ошибки в системе
class tx_infoblock_scanerror {
var $error; //переменая для разещения ошибок...
var $count_error = 0; //переменная для храенния кол-ва ошибок

	function main(){
	
		//Собираем ошибки...
		$this -> validation_LAST_INSTALL_IN_EXT_LIST(); // Вадилация проверки установленности расширения в "списке расширений" последним
		$this -> validation_NEW_TABLE(); // Валидация новых таблиц
		$this -> validation_NEW_TABLE_PROJECT_SETTINGS(); // Валидация новых таблиц (для настроек)
		$this -> validation_NEW_CONTENT_ELEMENT(); // Валидация новых элементов контента
		$this -> validation_NEW_PAGE_DOKTYPE(); // Вадилация новых типов страниц 
		$this -> validation_ADD_COLUMNS(); // Вадилация добавлений колонок
		$this -> validation_SYS_FILE_UPLOADS(); // Вадилация файловых описаний на предмет дублирования
		$this -> validation_DIFFERENT_CONFIG_COLUMNS(); // Проверка не зарег. ли на 1-MySQL-колонку разные config-и.
		
		    // -- Сильные ошибки --  
    
    #3777 - накопитель стандарт/служебный [№-накопителя] не подгреплен mysql-таблицей 
    #3029 - не все дополнительные свойства накопителя подкреплены mysql-колонкой [№-накопителя, №колонки-ключ-смотреть в папке всех колонок] 
    #4001 - есть повторные описания файлов в таблице 'sys_file' 
      /*
        Очистить дубли к ошибке #4001 можно с моподщью запроса: 
    DELETE FROM sys_file WHERE identifier IN ( 
      SELECT 
        identifier 
      FROM ( SELECT identifier, COUNT(identifier) AS `Cnt` FROM sys_file GROUP BY `identifier` ) AS t 
      WHERE 
        Cnt>1 
    ) 
	*/
      
    /* [поддержка не включена!] 
      
        Здесь будет выводиться цепочка к родителя из id-rootline - что бы человек мог найти... 1.3.6. 
        #4034 - указан неизвестный тип накопителя-стандарт [№-накопителя] 
        #4035 - указан неизвестный тип дополнительного свойства [№-накопителя] 
        #4036 - указан неизвестный тип структуры атрибутов [№-накопителя] 
      
        -- Не сильные ошибки -- 
        #3034 - в информационных накопителя [№-накопителя, колонка] имеются не задейстованные в структурах/палеттах колонки 
      
    */ 
		
		//Записываем количетсво ошибок в файл
		$handleConstant = fopen(PATH_site . 'typo3temp/error-count.txt', 'w+');
		fwrite($handleConstant, $this->count_error); //Запись массива (в виде строки)
		fclose($handleConstant);
		
		//Коды ошибок вы можете посмотреть в сервисах...
		if ($this->error == null) {
			return "В результате сканирования ошибок в системе не найдено...";
		
		} else {
			$string = null;
			foreach ($this->error as $kError => $vError) {
				switch($kError) {
					case 'NEW_TABLE':
						$string .= "<p><b><img src='/typo3conf/ext/air_table/res/v3/NEW-TABLE.png' style='vertical-align: middle;'> ";
						$string .= "Ошибки в новых таблицах:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'NEW_TABLE_PROJECT_SETTINGS':
						$string .= "<p><b><img src='/typo3conf/ext/air_table/res/v3/NEW-TABLE-PROJECT-SETTINGS.png' style='vertical-align: middle;'> ";
						$string .= "Ошибки в новых таблицах для настроек сайта:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'NEW_CONTENT_ELEMENT':
						$string .= "<p><b><img src='/typo3conf/ext/air_table/res/v3/NEW-CONTENT-ELEMENT.png' style='vertical-align: middle;'> ";
						$string .= "Ошибки в новых элементах контента:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'NEW_PAGE_DOKTYPE':
						$string .= "<p><b><img src='/typo3conf/ext/air_table/res/v3/NEW-PAGE-DOKTYPE.png' style='vertical-align: middle;'> ";
						$string .= "Ошибки в новых типах страниц:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'ADD_COLUMNS':
						$string .= "<p><b><img src='/typo3conf/ext/air_table/res/v3/ADD-COLUMN.png' style='vertical-align: middle;'> ";
						$string .= "Ошибки при добавлении колонок в таблицы:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'SYS_FILE_UPLOADS':
						$string .= "<p><b>Ошибки в таблице файловых описаний - имеются дублирование следующих индентификаторов:</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'LAST_INSTALL_IN_EXT_LIST':
						$string .= "<p><b>Расширение не устанволенно последним!</b></p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
					case 'DIFFERENT_CONFIG_COLUMNS':
						$string .= "<p><b>В таблице имеются колонки с разной config-конфигурацией на 1 MySQL-колонку</b>. Актуально для \"multistructure\" и \"multistructure_isNewPageModxTV\": [NEW-PAGE-DOKTYPE], [NEW-PAGE-MODXTV], [NEW-TABLE-MULTISTRUCTURE]. В настоящем это является ошибкой, т.к. при сохранении записей, где на одну MySQL-колонку назначены разные конфиги, сохранение данных не происходит - см.#20320432 (например файлы - не загружаются)!</p><br />";
						$string .= implode (";<br /><br />" , $vError);
						$string .= "<br /><br />";
						break;
				}
			}
			// $string .= '<input value="Справка - ?" onclick="iblFunction_iblbloc_Documentation_open(this)" type="button" style="height: 19px;">';
			return $string;
		}
	
	}
	
		// Валидация новых таблиц
	function validation_NEW_TABLE(){
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			SELECT * FROM `tx_air_elements` 
			WHERE (
					`type_element` LIKE 'new-infoblock-standart%' AND
					`type_element` != 'new-infoblock-standart-settings'
				)
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				if ($ardamp['key_element'] == null) {
					$this->error['NEW_TABLE'][] = "Не задан MySQL-ключ таблицы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if ($allListKeyTableIsset[$ardamp['key_element']] == 1) {
					$this->error['NEW_TABLE'][] = "Указан повторный ".$this->errorKeyElement($ardamp['key_element'])." MySQL-ключ таблицы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if(!preg_match("/^[a-zA-Z_][a-zA-Z0-9_]*$/", $ardamp['key_element'])) {
					$this->error['NEW_TABLE'][] = "В MySQL-ключе таблицы ".$this->errorKeyElement($ardamp['key_element'])." указаны не допустимые символы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				$allListKeyTableIsset[$ardamp['key_element']] = 1;
			}
		}
	}
	
		// Валидация новых таблиц (для настроек)
	function validation_NEW_TABLE_PROJECT_SETTINGS() {
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			SELECT * FROM `tx_air_elements` 
			WHERE (
					`type_element` = 'new-infoblock-standart-settings'
				)
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				if ($ardamp['key_element'] == null) {
					$this->error['NEW_TABLE_PROJECT_SETTINGS'][] = "Не задан MySQL-ключ таблицы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if ($allListKeyTableIsset[$ardamp['key_element']] == 1) {
					$this->error['NEW_TABLE_PROJECT_SETTINGS'][] = "Указан повторный ".$this->errorKeyElement($ardamp['key_element'])." MySQL-ключ таблицы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if(!preg_match("/^[a-zA-Z_][a-zA-Z0-9_]*$/", $ardamp['key_element'])) {
					$this->error['NEW_TABLE_PROJECT_SETTINGS'][] = "В MySQL-ключе таблицы ".$this->errorKeyElement($ardamp['key_element'])." указаны не допустимые символы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if(!strstr($ardamp['key_element'], "tx_web_settings")) {
					$this->error['NEW_TABLE_PROJECT_SETTINGS'][] = "В MySQL-ключе таблицы ".$this->errorKeyElement($ardamp['key_element'])." не найден обязательный префикс \"tx_web_settings, tx_web_settings_s2, tx_web_settings_3...\" - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				$allListKeyTableIsset[$ardamp['key_element']] = 1;
			}
		}
	}
	
		// Валидация новых элементов контента
	function validation_NEW_CONTENT_ELEMENT() {
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			SELECT * FROM `tx_air_elements` 
			WHERE (
					`type_element` LIKE 'new-infoblock-modification%' AND
					`key_element` = 'tt_content'
				)
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				if ($ardamp['sub_key_element'] == null) {
					$this->error['NEW_CONTENT_ELEMENT'][] = "Не задан ключ элемента контента - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if ($allListKeyTableIsset[$ardamp['sub_key_element']] == 1) {
					$this->error['NEW_CONTENT_ELEMENT'][] = "Указан повторный ключ ".$this->errorKeyElement($ardamp['sub_key_element'])." элемента контента - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if(!preg_match("/^[a-zA-Z_][a-zA-Z0-9_]*$/", $ardamp['sub_key_element'])) {
					$this->error['NEW_CONTENT_ELEMENT'][] = "В ключе ".$this->errorKeyElement($ardamp['sub_key_element'])." элемента контента указаны не допустимые символы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				$allListKeyTableIsset[$ardamp['sub_key_element']] = 1;
			}
		}
	}
	
		// Вадилация новых типов страниц 
	function validation_NEW_PAGE_DOKTYPE() {
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			SELECT * FROM `tx_air_elements` 
			WHERE (
					`type_element` LIKE 'new-infoblock-modification%' AND
					`key_element` = 'pages'
				)
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				if ($ardamp['sub_key_element'] == null) {
					$this->error['NEW_PAGE_DOKTYPE'][] = "Не задан ключ типа страницы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
				if ($allListKeyTableIsset[$ardamp['sub_key_element']] == 1) {
					$this->error['NEW_PAGE_DOKTYPE'][] = "Указан повторный ключ ".$this->errorKeyElement($ardamp['sub_key_element'])." типа страницы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
					// для [Doc] // (так разбили на типы на скорую руку)
				if (strstr( $ardamp['title'], "[Doc]")) {
					if(!preg_match("/^[0-9]*$/", $ardamp['sub_key_element'])) {
						$this->error['NEW_PAGE_DOKTYPE'][] = "В ключе ".$this->errorKeyElement($ardamp['sub_key_element'])." типа страницы указаны не допустимые символы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
						$this->count_error ++;
					}
				}
					// для [Mod] // (так разбили на типы на скорую руку)
				if (strstr( $ardamp['title'], "[Mod]")) {
					if(!preg_match("/^[a-zA-Z_][a-zA-Z0-9_]*$/", $ardamp['sub_key_element'])) {
						$this->error['NEW_PAGE_DOKTYPE'][] = "В ключе ".$this->errorKeyElement($ardamp['sub_key_element'])." типа страницы указаны не допустимые символы - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
						$this->count_error ++;
					}
				}
				$allListKeyTableIsset[$ardamp['sub_key_element']] = 1;
			}
		}
	}
	
		// Вадилация добавлений колонок
	function validation_ADD_COLUMNS() {
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			SELECT * FROM `tx_air_elements` 
			WHERE (
					`type_element` LIKE 'new-add-columns'
				)
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				if ($ardamp['key_element'] != "pages" AND
					$ardamp['key_element'] != "tt_content" AND
					$ardamp['key_element'] != "sys_file_uploads" AND
					$ardamp['key_element'] != "fe_users"
				) {
					$this->error['ADD_COLUMNS'][] = "Указанный ключ ".$this->errorKeyElement($ardamp['key_element'])." не входит в число разрешенных ключей (pages,tt_content,sys_file,fe_users) - ".$this->linkTo_system_value_path_ts_file_($ardamp['_system_value_path_ts_file_']);
					$this->count_error ++;
				}
			}
		}
	}
	
		// Вадилация файловых описаний на предмет дублирования
	function validation_SYS_FILE_UPLOADS() {
		$res = $GLOBALS['TYPO3_DB']->sql_query("
			# Старый вариант
			# SELECT identifier,uid FROM sys_file_uploads WHERE identifier IN (
			#   SELECT
			# 	identifier
			#   FROM ( SELECT identifier, COUNT(identifier) AS `Cnt` FROM sys_file_uploads GROUP BY `identifier` ) AS t
			#   WHERE
			# 	Cnt>1
			# )
			# Новый вариант (группировка с учетом регистра)
			SELECT identifier,uid, COUNT(*) AS c FROM sys_file_uploads 
			GROUP BY BINARY identifier HAVING c > 1;
		");
		$num = $GLOBALS['TYPO3_DB']->sql_num_rows ($res);
		if ($num > 0){
			while ( ($ardamp = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) ) {
				$this->error['SYS_FILE_UPLOADS'][ $ardamp['identifier'] ] = $ardamp['identifier'];
				$this->count_error ++;
			}
		}
	}
	
		// Вадилация проверки установленности расширения в "списке расширений" последним
	function validation_LAST_INSTALL_IN_EXT_LIST() {
		if (file_exists(PATH_site.'typo3conf/LocalConfiguration.php')) { // TYPO3 6.1+
			$arrExtList = $GLOBALS['TYPO3_CONF_VARS']['EXT']['extListArray'];
			$lastExt = $arrExtList[count($arrExtList)-1];
			if ($lastExt != "air_table") {
				$this->error['LAST_INSTALL_IN_EXT_LIST'][1] = "Расширение Air Table должно числится последним в списке установленных расширений!";
				$this->count_error ++;
			}
		} else {
			$arrExtList = explode("," , $GLOBALS['TYPO3_CONF_VARS']['EXT']['extList']);
			$lastExt = $arrExtList[count($arrExtList)-1];
			if ($lastExt != "air_table") {
				$this->error['LAST_INSTALL_IN_EXT_LIST'][1] = "Расширение Air Table должно числится последним в списке установленных расширений!";
				$this->count_error ++;
			}
		}
	}
	
		// Проверка не зарег. ли на 1-MySQL-колонку разные config-и.
	function validation_DIFFERENT_CONFIG_COLUMNS(){
		foreach($GLOBALS['TCA'] as $tableName => $tableValue){
			t3lib_div::loadTCA( $tableName );
			$cConfigList = array();
			
				// А) Проверяем мультиструктурные таблицы ([NEW-PAGE-DOKTYPE], [NEW-TABLE-MULTISTRUCTURE])
			if(isset($tableValue['multistructure'])){
				foreach($tableValue['multistructure'] as $sName => $sValue){
					foreach($sValue['types']['columns'] as $cName => $cValue){
						if(!preg_match('/^\+?\d+$/', $cName)){ // проверка, что название колонки - это не число!
							$indef = md5($cName . serialize($cValue));
							$cConfigList[$cName][] = $indef;
						}
					} 
				}
			}
			
				// Б) Проверяем [NEW-PAGE-MODXTV]
			if(isset($tableValue['multistructure_isNewPageModxTV'])){
				foreach($tableValue['multistructure_isNewPageModxTV'] as $sName => $sValue){
					foreach($sValue['types']['columns'] as $cName => $cValue){
						if(!preg_match('/^\+?\d+$/', $cName)){ // проверка, что название колонки - это не число!
							$indef = md5($cName . serialize($cValue));
							$cConfigList[$cName][] = $indef;
						}
					} 
				}
			}
			
				// Выполняем проверку
			foreach($cConfigList as $cName => $cValue){
				for($i = 1; $i < count($cValue); $i++){
					if($cValue[$i-1] != $cValue[$i]){
						$this->error['DIFFERENT_CONFIG_COLUMNS'][] = "В таблице \"".$tableName."\" на одну MySQL-колонку \"".$cName."\" зарегестрированны разные config-и.";
						$this->count_error ++;
						break;
					}
				}
			}
			# $handleConstant = fopen(PATH_site . 'test_3333___.txt', 'a+');
			# fwrite($handleConstant, print_r($cConfigList,TRUE)); //Запись массива (в виде строки)
			# fclose($handleConstant);
			
		}
	}
	
		// Ссылка на файл с описанием конфигурации, где найдена ошибка.
	function linkTo_system_value_path_ts_file_($val){
		return "<a href='/".$val."' target='_blank'><img src='/typo3conf/ext/air_table/res/ts.png' style='vertical-align: middle;'></a>";
	}
	
		// Ссылка на файл с описанием конфигурации, где найдена ошибка.
	function errorKeyElement($val){
		return "\"<span style='color: red;'>" . $val . "</span>\"";
	}

}

?>