<?php
require_once(PATH_site.'t3lib/tree/pagetree/interfaces/interface.t3lib_tree_pagetree_interfaces_collectionprocessor.php');
class tx_air_table_pagetree_DataProvider implements t3lib_tree_pagetree_interfaces_CollectionProcessor {
		
	/**
	 * @abstract
	 * @param \TYPO3\CMS\Backend\Tree\Pagetree\PagetreeNode $node
	 * @param int $mountPoint
	 * @param int $level
	 * @param \TYPO3\CMS\Backend\Tree\Pagetree\PagetreeNodeCollection $nodeCollection
	 * @return void
	 */
	public function postProcessGetNodes($node, $mountPoint, $level, $nodeCollection) {
		# foreach ($nodeCollection as $node) {
		#	/** @var $node \TYPO3\CMS\Backend\Tree\TreeNode */
		#	$this->highlightVersionizedElements($node);
		# }
		# $node->setBackgroundColor('red');
		
		foreach ($nodeCollection as $node) {
			
				// Если запрещено перемещение drag & drop
			/** @var $node \TYPO3\CMS\Backend\Tree\TreeNode */
			$recordData = $node->getRecord();
			if ($recordData['tx_air_table_disable_drag_and_drop_this_page'] == 1) {
				// $node->setAllowChildren(FALSE); // запретить создание дочек
				$node->setDraggable(FALSE); // запретить перемещение
				// $node->setCls('ver-versions');
			}
			
		}
		
		
	}

	/**
	 * @abstract
	 * @param \TYPO3\CMS\Backend\Tree\Pagetree\PagetreeNode $node
	 * @param string $searchFilter
	 * @param int $mountPoint
	 * @param \TYPO3\CMS\Backend\Tree\Pagetree\PagetreeNodeCollection $nodeCollection
	 * @return void
	 */
	public function postProcessFilteredNodes($node, $searchFilter, $mountPoint, $nodeCollection) {
		# foreach ($nodeCollection as $node) {
		# 	/** @var $node \TYPO3\CMS\Backend\Tree\TreeNode */
		#	$this->highlightVersionizedElements($node);
		# }
	}

	/**
	 * @abstract
	 * @param string $searchFilter
	 * @param \TYPO3\CMS\Backend\Tree\Pagetree\PagetreeNodeCollection $nodeCollection
	 * @return void
	 */
	public function postProcessGetTreeMounts($searchFilter, $nodeCollection) {
		# foreach ($nodeCollection as $node) {
		#	/** @var $node \TYPO3\CMS\Backend\Tree\TreeNode */
		#	$this->highlightVersionizedElements($node);
		# }
	}

	/**
	 * Sets the CSS Class on all pages which have versioned records
	 * in the current workspace
	 *
	 * @param \TYPO3\CMS\Backend\Tree\TreeNode $node
	 * @return void
	 */
	# public function highlightVersionizedElements(\TYPO3\CMS\Backend\Tree\TreeNode $node) {
	# 	$node->setCls('ver-versions');
	# }


	
}
	
?>